/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package helper;

/**
 *
 * @author Lukas
 */

//import bpnet.svi.v2014.KMeans.Cluster;
import classifier.Dataset;
import classifier.Sample;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Paint;
import java.awt.image.BufferedImage;
import java.awt.image.ImageObserver;
import javax.swing.JFrame;
import javax.swing.JPanel;
import neuron.Network;
import neuron.Neuron;
import neuron.perceptron.PerceptronLayer;
import neuron.perceptron.PerceptronNetwork;
import neuron.perceptron.PerceptronNeuron;

//Scatter plot by m?l bt volan p?ed za?tkem cyklu epoch, vytvo?en isntance
// na konci, po end epoch zavoln plot()
// tisknout to kadou stou iteraci

public class ScatterPlot extends JFrame implements ImageObserver {

    int x, y;
    BufferedImage graph;
    Dataset data;
    JPanel panel;
    Network net;

    public ScatterPlot(int x, int y) throws Exception {
        super("Scatter Plot");
        /*         if (((InputLayer)net.layers.get(0)).neurons.length != 2) {
         throw new Exception("incompatible network");
         }
         */ this.x = x;
        this.y = y;
        graph = new BufferedImage(x, y, BufferedImage.TYPE_INT_RGB);
        panel = new JPanel() {
            @Override
            public void paint(Graphics gc) {
                gc.drawImage(graph, 0, 0, panel);
            }
        };
        panel.setSize(x, y);
        getContentPane().add(panel);
        setResizable(false);
        setSize(x, y);
        setVisible(true);
    }

    public void plot(PerceptronNetwork net, Dataset data) {
        Graphics gc = graph.createGraphics();
        for (int i = 0; i < y; i++) {
            for (int j = 0; j < x; j++) {
                double fy = (double) i / y;
                double fx = (double) j / x;
                net.recall(new double[]{fx, fy});
                int c = (int) (255 * net.getOutputLayer().neurons[0].y + 0.5);
                c = c & 0xFF;
                graph.setRGB(j, y - i - 1, c << 16 | c << 8 | c);
            }
        }
        PerceptronLayer hidden = (PerceptronLayer) net.layers.get(1);
        gc.setColor(Color.yellow);
        for (Neuron neuron : hidden.neurons) {
            PerceptronNeuron n = (PerceptronNeuron) neuron;
            double y1 = -n.treshold / n.weights[1];
            double y2 = -n.treshold / n.weights[1] - n.weights[0] / n.weights[1];
            double x1 = -n.treshold / n.weights[0];
            double x2 = -n.treshold / n.weights[0] - n.weights[1] / n.weights[0];
            if ((0 <= y1 && y1 <= 1) && (0 <= y2 && y2 <= 1)) {
                gc.drawLine(0, (int) (y - y * y1 - 0.5), x, (int) (y - y * y2 - 0.5));
            }
            if ((0 <= y1 && y1 <= 1) && (0 <= x1 && x1 <= 1)) {
                gc.drawLine(0, (int) (y - y * y1 - 0.5), (int) (x * x1 + 0.5), y);
            }
            if ((0 <= y1 && y1 <= 1) && (0 <= x2 && x2 <= 1)) {
                gc.drawLine(0, (int) (y - y * y1 - 0.5), (int) (x * x2 + 0.5), 0);
            }
            if ((0 <= y2 && y2 <= 1) && (0 <= x1 && x1 <= 1)) {
                gc.drawLine(x, (int) (y - y * y2 - 0.5), (int) (x * x1 + 0.5), y);
            }
            if ((0 <= y2 && y2 <= 1) && (0 <= x2 && x2 <= 1)) {
                gc.drawLine(x, (int) (y - y * y2 - 0.5), (int) (x * x2 + 0.5), 0);
            }
            if ((0 <= x1 && x1 <= 1) && (0 <= x2 && x2 <= 1)) {
                gc.drawLine((int) (x * x1 + 0.5), y, (int) (x * x2 + 0.5), 0);
            }
        }
        for (Sample s : data.getSamples()) {
            int sx = (int) (x * s.inputs[0] + 0.5);
            int sy = y - (int) (y * s.inputs[1] + 0.5);
            if (s.outputs[0] > 0.5) {
                gc.setColor(Color.red);
            } else {
                gc.setColor(Color.green);
            }
            gc.drawLine(sx - 5, sy, sx + 5, sy);
            gc.drawLine(sx, sy - 5, sx, sy + 5);
        }
        panel.repaint();
    }
    
        public void plot(Dataset data) {
//        int numOfcl = kmeans.getClusterCount();
//        int bits = (int) (Math.log(numOfcl) / Math.log(2));
//        bits = (bits % 3 > 0) ? bits / 3 + 1 : bits / 3;
//        if (bits > 8) {
//            bits = 8;
//        }
        Graphics gc = graph.createGraphics();
        for (int i = 0; i < y; i++) {
            for (int j = 0; j < x; j++) {
                double fy = (double) i / y;
                double fx = (double) j / x;
                int cl;
//                cl = kmeans.classify(new double[]{fx, fy});
//                int mask1 = ~(0xFFFFFFFF << bits);
//                int mask2 = (0xFF >>> bits);
//                int b = ((cl & mask1) << (8 - bits + 1)) - (((cl & mask1) == 0) ? 0 : 1);
//                mask1 <<= bits;
//                int g = ((cl & mask1) << (8 - 2 * bits + 1)) - (((cl & mask1) == 0) ? 0 : 1);
//                mask1 <<= bits;
//                int r = ((cl & mask1) << (8 - 3 * bits + 1)) - (((cl & mask1) == 0) ? 0 : 1);
//                graph.setRGB(j, y - i - 1, r << 16 | g << 8 | b);
            }
        }
        for (Sample s : data.getSamples()) {
            int sx = (int) (x * s.inputs[0] + 0.5);
            int sy = y - (int) (y * s.inputs[1] + 0.5);
            if (s.outputs[0] > 0.5) {
                gc.setColor(Color.red);
            } else {
                gc.setColor(Color.green);
            }
            gc.drawLine(sx - 5, sy, sx + 5, sy);
            gc.drawLine(sx, sy - 5, sx, sy + 5);
        }
        gc.setColor(Color.white);
        panel.repaint();
    }

    //ORIGIN METHOD
//    public void plot(KMeans kmeans, Dataset data) {
//        int numOfcl = kmeans.getClusterCount();
//        int bits = (int) (Math.log(numOfcl) / Math.log(2));
//        bits = (bits % 3 > 0) ? bits / 3 + 1 : bits / 3;
//        if (bits > 8) {
//            bits = 8;
//        }
//        Graphics gc = graph.createGraphics();
//        for (int i = 0; i < y; i++) {
//            for (int j = 0; j < x; j++) {
//                double fy = (double) i / y;
//                double fx = (double) j / x;
//                int cl;
//                cl = kmeans.classify(new double[]{fx, fy});
//                int mask1 = ~(0xFFFFFFFF << bits);
//                int mask2 = (0xFF >>> bits);
//                int b = ((cl & mask1) << (8 - bits + 1)) - (((cl & mask1) == 0) ? 0 : 1);
//                mask1 <<= bits;
//                int g = ((cl & mask1) << (8 - 2 * bits + 1)) - (((cl & mask1) == 0) ? 0 : 1);
//                mask1 <<= bits;
//                int r = ((cl & mask1) << (8 - 3 * bits + 1)) - (((cl & mask1) == 0) ? 0 : 1);
//                graph.setRGB(j, y - i - 1, r << 16 | g << 8 | b);
//            }
//        }
//        for (Sample s : data) {
//            int sx = (int) (x * s.inputs[0] + 0.5);
//            int sy = y - (int) (y * s.inputs[1] + 0.5);
//            if (s.outputs[0] > 0.5) {
//                gc.setColor(Color.red);
//            } else {
//                gc.setColor(Color.green);
//            }
//            gc.drawLine(sx - 5, sy, sx + 5, sy);
//            gc.drawLine(sx, sy - 5, sx, sy + 5);
//        }
//        gc.setColor(Color.white);
//        for (Cluster c : kmeans.getClusters()) {
//            int sx = (int) (x * c.getCenter()[0] + 0.5);
//            int sy = y - (int) (y * c.getCenter()[1] + 0.5);
//            gc.drawArc(sx - 5, sy - 5, 10, 10, 0, 360);
//            gc.drawLine(sx - 10, sy, sx + 10, sy);
//            gc.drawLine(sx, sy - 10, sx, sy + 10);
//        }
//        panel.repaint();
//    }

//    public void plot(RbfNetwork rbf, Dataset data, boolean output) {
//        int numOfcl = rbf.hidden.neurons.length + 1;
//        int bits = (int) (Math.log(numOfcl) / Math.log(2));
//        bits = (bits % 3 > 0) ? bits / 3 + 1 : bits / 3;
//        if (bits > 8) {
//            bits = 8;
//        }
//        Graphics gc = graph.createGraphics();
//        for (int i = 0; i < y; i++) {
//            for (int j = 0; j < x; j++) {
//                double fy = (double) i / y;
//                double fx = (double) j / x;
//                rbf.recall(new double[]{fx, fy});
//                int cl = 0;
//                if (output) {
//                    cl = (int) (255 * rbf.getOutputLayer().neurons[0].y + 0.5);
//                    cl = cl & 0xFF;
//                    graph.setRGB(j, y - i - 1, cl << 16 | cl << 8 | cl);
//                } else {
//                    double maxy = rbf.hidden.neurons[0].y;
//                    for (int k = 1; k < rbf.hidden.neurons.length; k++) {
//                        double yy = rbf.hidden.neurons[k].y;
//                        if (maxy < yy) {
//                            maxy = yy;
//                            cl = k;
//                        }
//                    }
//                    cl += 1;
//                    int mask1 = ~(0xFFFFFFFF << bits);
//                    int mask2 = (0xFF >>> bits);
//                    int b = ((cl & mask1) << (8 - bits + 1)) - (((cl & mask1) == 0) ? 0 : 1);
//                    mask1 <<= bits;
//                    int g = ((cl & mask1) << (8 - 2 * bits + 1)) - (((cl & mask1) == 0) ? 0 : 1);
//                    mask1 <<= bits;
//                    int r = ((cl & mask1) << (8 - 3 * bits + 1)) - (((cl & mask1) == 0) ? 0 : 1);
//                    b = (int) (b * maxy + 0.5);
//                    g = (int) (g * maxy + 0.5);
//                    r = (int) (r * maxy + 0.5);
//                    graph.setRGB(j, y - i - 1, r << 16 | g << 8 | b);
//                }
//            }
//        }
//        for (Sample s : data) {
//            int sx = (int) (x * s.inputs[0] + 0.5);
//            int sy = y - (int) (y * s.inputs[1] + 0.5);
//            if (s.outputs[0] > 0.5) {
//                gc.setColor(Color.red);
//            } else {
//                gc.setColor(Color.green);
//            }
//            gc.drawLine(sx - 5, sy, sx + 5, sy);
//            gc.drawLine(sx, sy - 5, sx, sy + 5);
//        }
//        gc.setColor(Color.black);
//        for (Neuron n : rbf.hidden.neurons) {
//            int sx = (int) (x * ((RbfNeuron) n).c[0] + 0.5);
//            int sy = y - (int) (y * ((RbfNeuron) n).c[1] + 0.5);
//            gc.drawArc(sx - 5, sy - 5, 10, 10, 0, 360);
//            gc.drawLine(sx - 10, sy, sx + 10, sy);
//            gc.drawLine(sx, sy - 10, sx, sy + 10);
//        }
//        panel.repaint();
//    }

}