package interfaces;

import java.io.PrintStream;
import java.util.ArrayList;

import classifier.Dataset;
import classifier.Sample;

public interface IDataset {
	 
	void loadFromText(String filename);  
	  
	  void loadFromCsv(String filename);
	  
	  void load(String filename);
	  
	  void save(String filename);
	  
	  void saveToTextFile(String filename);
	  
	  void saveToCsvFile(String filename);
	  
	  int getSize();
	  
	  ArrayList<Sample> getSamples();
	  
	  void randomInit(long seed, int access);
	  
	  Sample getRandom();
	  
	  void append(Dataset dataset);
	  
	  void clearSamples();
	  
	  void removeSample(int index);
	  
	  void removeSample(Sample sample);
	  
	  void addSample(Sample sample);
	  
	  void print(PrintStream out);
	
}