package neuron;

import java.util.Random;

public class Layer {
	
    public Neuron[] neurons;

    public Layer(int size) {
    	neurons = new Neuron[size];
    }
    
    public Layer(int size, Layer input) {
    	neurons = new Neuron[size];
    	for (Neuron neuron : neurons) {
    		neuron.setInputs(input.getNeurons());
    	}
    }
    
    public void recall() {

        for (Neuron neuron : neurons) {
            neuron.recall();
        }
    }
    
    public void initWeights(double min, double max, Random rand) {
    	for (Neuron neuron : neurons) {
    		neuron.initWeights(min, max, rand);
    	}
    }

    //~ Getters and Setters
    
    public Neuron[] getNeurons() {
    	return this.neurons;
    }
    
    public void setNeurons(Neuron[] neurons) {
    	this.neurons = neurons;
    }
}