package neuron;

import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Random;

import classifier.Dataset;
import classifier.Sample;

// pro RBF budeme muset dodělat sigmu
// metody na set sigmy a get sigmy
// sigma ur?uje strmost sigmy
public abstract class Network {

    public ArrayList<Layer> layers = new ArrayList<>();

    public void recall() {
        for (int i = 0; i < layers.size(); i++) {
            if (!(layers.get(i) instanceof InputLayer)) {
                this.layers.get(i).recall();
            }
        }
    }

    public InputLayer getInputLayer() {
        return (InputLayer) layers.get(0);
    }

    public Layer getOutputLayer() {
        return layers.get(layers.size() - 1);
    }

    public void addLayer(Layer layer) {
        layers.add(layer);
    }

    public void initWeights(double min, double max, Random rand) {
        for (Layer layer : layers) {
            if (!(layer instanceof InputLayer)) {
                layer.initWeights(min, max, rand);
            }
        }
    }

    public void recall(Dataset dataset, PrintStream out) {

        for (Sample sample : dataset.getSamples()) {
            InputLayer inputLayer = (InputLayer) getLayers().get(0);
            inputLayer.setInputs(sample.getInputs());
            this.recall();
            Neuron[] neurons = this.layers.get(layers.size() - 1).getNeurons();
            for (int i = 0; i < neurons.length; i++) {
                out.printf("%7.6f", neurons[i].y); // dosadit aktualni sample
                out.print(' ');
            }
        }
    }
    
    //Optimalizan algoritmus           
    //Petruban algoritmus
    
            
    

    /**
     * DU metoda Provede metodu recall a vytiskne vystupy site v citelnem
     * formatu pro kazdy vzor.
     */
//    public void recall(Dataset dataset, PrintStream out) {
//        for (Sample sample : dataset.getSamples()) {
//            InputLayer inputLayer = getInputLayer();
//            inputLayer.setInputs(sample.getInputs());
//            this.recall();
//
//             Neuron[] neurons = this.layers.get(this.layers.size() - 1).getNeurons(); 
//             for (int i = 0; i < neurons.length; i ++){
//                 
//             }
//
////            for (int i = 0; i < sample.getOutputs().length; i++) {
////                out.printf("%7.3f", sample.getOutputs()[i]);
////                out.print(' ');
////            }
//        }
//    }
//    public void recall(Dataset dataset, PrintStream out) {
//
//        for (Sample sample : dataset.getSamples()) {
//            InputLayer inputLayer = (InputLayer) getLayers().get(0);
//            inputLayer.setInputs(sample.getInputs());
//            this.recall();
//            Neuron[] neurons = this.layers.get(layers.size() - 1).getNeurons();
//            for (int i = 0; i < neurons.length; i++) {
//                out.printf("%7.3f", neurons[i].y); // dosadit aktualni sample
//                out.print(' ');
//            }
//        }
//    }
    /**
     * DU metoda Vytiskne stav site do jednoho radku. Format: w11, w12,
     * threshold.
     */
    public abstract void printActualState(PrintStream out);

    //~ Getters and Setters
    public ArrayList<Layer> getLayers() {
        return layers;
    }

    public void setLayers(ArrayList<Layer> layers) {
        this.layers = layers;
    }

}
