package neuron.perceptron;

import neuron.Layer;
import neuron.Neuron;

public class PerceptronLayer extends Layer {

    protected Layer previousLayer;

    public void initLearning() {
        for (int i = 0; i < neurons.length; i++) {
            ((PerceptronNeuron) neurons[i]).initLearning();
        }
    }

    public void initEpoch() {
        for (int i = 0; i < neurons.length; i++) {
            ((PerceptronNeuron) neurons[i]).initEpoch();
        }
    }

    public void learn() {
        for(int i = 0; i < neurons.length; i ++){
            ((PerceptronNeuron)neurons[i]).learn();
        }
    }

    public void endEpoch(double eta, double alpha) {
        for (int i = 0; i < neurons.length; i++) {
            ((PerceptronNeuron) neurons[i]).endEpoch(eta, alpha);
        }
    }

    public void endLearning() {
        for (int i = 0; i < neurons.length; i++) {
            ((PerceptronNeuron) neurons[i]).endLearning();
        }
    }

    //PerceptronNeuron copyerd above
    protected double outputDelta(double[] desiredOutput) {
        double diff;
        // err = suma chyb na vstupu
        double err = 0;

        PerceptronNeuron n;

        for (int i = 0; i < neurons.length; i++) {
            diff = desiredOutput[i] - neurons[i].y;

            n = ((PerceptronNeuron) neurons[i]);
            n.delta = n.y * (1 - n.y) * diff;
//            ((PerceptronNeuron)neurons[i]).delta = diff * neurons[i].y * 1-neurons[i].y;
            err = diff * diff;
        }

        // Akumulovan chyba pes celou trnovac a uc mnoinu, slou jako indiktor nauenosti st.
        return err / neurons.length;
    }

    public void backPropagate() {
        for (int j = 0; j < previousLayer.getNeurons().length; j++) {

            // souet pispvk w* delta; delta * vha pro vechny vstupy danho neuronu
            double ds = 0;
            for (int i = 0; i < neurons.length; i++) {
                PerceptronNeuron neuron = ((PerceptronNeuron) neurons[i]);

                ds += neuron.delta * neuron.weights[j];
            }

            //Probably
            PerceptronNeuron in = ((PerceptronNeuron) previousLayer.getNeurons()[j]);
            in.delta = in.y * (1 - in.y) * ds;
        }
    }

    // Na rovni st, nejdv inicializace uen, inicializace vah, inicializace epochy, pak bude loop. 
    // Respektive bude smyka i ped inicializac epochy, uvnit bude smyuka pes vechny vzoru trnovac mnoiny,
    // kde bude recall, potom bude vpoet delta na vstupn vrstv, pot zavolme learning na vech vrstvch, kde bude backPropage. 
    public PerceptronLayer(int size, Layer inputs) {
        super(size);
        this.previousLayer = inputs;
        for (int i = 0; i < size; i++) {
            neurons[i] = new PerceptronNeuron();
            neurons[i].setInputs(inputs.getNeurons());
        }
    }
}
