package neuron.perceptron;

import java.util.Random;

import neuron.Neuron;

//Postavit sit s perceptronu 2 vstupy, 2 skryte; 
public class PerceptronNeuron extends Neuron {

    public double[] weights;
    public double treshold;

    protected double delta; // Chyba pipadajc na jeden neuron
    protected double[] deltaW;  // Poadovan zmna vah, lev strana delta pravidla
    protected double deltaTheta;  // Poadovan zmna prahu, lev strana delta pravidla 
    protected double[] oldDeltaW; // Pedchoz hodnota delta, kvli setrvanosti
    protected double oldDeltaTheta; // pedchoz hodnota deltaTheta

    // Budeme dlat batch algoritmus, plnn a na zvr
    // Odstrann parametr kvli batch algoritmu
    // public void initLearning(double eta, double alpha){
    public void initLearning() {
        delta = 0;
        deltaTheta = 0;
        oldDeltaTheta = 0;

        // Oproti moodle se li v tom e je tam potno s initLearning ve vy vrstv, proto je delta jednohodnotov a deltaW se nim nensob
        deltaW = new double[inputs.length];
        oldDeltaW = new double[inputs.length];
    }

    public void initEpoch() {
        deltaTheta = 0;       
        deltaW = new double[inputs.length];
    }

    public void learn() {
        // Vypoet novho nastaven vah
        for (int i = 0; i < inputs.length; i++) {
            deltaW[i] += delta * inputs[i].y;

            // Vypoet poadovan zmny prahu
            //Zde bylo += delta; Mon chyba. 
        }
        deltaTheta += delta;
    }

    public void endEpoch(double eta, double alpha) {
       for (int i = 0; i < inputs.length; i ++){
           
           double dw = eta * deltaW[i] + alpha * oldDeltaW[i]; 
           weights[i] += dw; 

//           double dth = eta * deltaTheta + alpha * oldDeltaTheta;           
//           treshold += dth;
           
           oldDeltaW[i] = dw; 
       }
       
       // Uprava prahu
       oldDeltaTheta = eta * deltaTheta + alpha * oldDeltaTheta;
       treshold += oldDeltaTheta; 
    }
    
    public void endLearning(){
        deltaW = null; 
        oldDeltaW = null; 
    }

    @Override
    public void recall() {
        double sum = treshold;
        for (int i = 0; i < inputs.length; i++) {

            sum += weights[i] * inputs[i].getY();

            y = 1.0 / (1.0 + Math.exp(-sum));
        }   
        // Jak vypadá parametr gama sigmoidní funkce; gama = 1;
        // y = 1/1+e^(-x)
        // jedna lomeno nekone?no = 0
        // e^- = 1/nekone?ná hodnota
        // e^+ nekone?no
    }

    @Override
    public void setInputs(Neuron[] inputs) {
        super.setInputs(inputs);
        weights = new double[inputs.length];
    }

    @Override
    public void initWeights(double min, double max, Random rand) {
        // Nastaveni vah
        for (int i = 0; i < weights.length; i++) {
            weights[i] = (max - min) * rand.nextDouble() + min;
        }
        // Nastaveni prahu
        treshold = (max - min) * rand.nextDouble() + min;
    }

    //~ Getters and Setters
    public double[] getWeights() {
        return weights;
    }

    public void setWeights(double[] weights) {
        this.weights = weights;
    }

    public double getTreshold() {
        return treshold;
    }

    public void setTreshold(double treshold) {
        this.treshold = treshold;
    }
}
