package neuron.rbf;

import java.util.Random;

import neuron.Neuron;

//Postavit sit s perceptronu 2 vstupy, 2 skryte; 

public class RBFNeuron extends Neuron {

	private double[] weights;
	private double treshold;
	private double sigma;
	double sum = treshold;

	@Override
	public void recall() {
		for (int i = 0; i < inputs.length; i++) {
			sum += Math.pow((weights[i] - inputs[i].getY()), 2.0);
		}

		y = Math.exp(-(Math.pow(sum, 2.0) / 2 * Math.pow(this.sigma, 2.0)));
	}

	@Override
	public void setInputs(Neuron[] inputs) {
		super.setInputs(inputs);
		weights = new double[inputs.length];
	}

	public void SetSigma(double value) {
		this.sigma = value;
	}

	public double GetSigma() {
		return this.sigma;
	}

	@Override
	public void initWeights(double min, double max, Random rand) {
		// Nastaveni prahu
		treshold = (max - min) * rand.nextDouble() + min;
		// Nastaveni vah
		for (int i = 0; i < weights.length; i++) {
			weights[i] = (max - min) * rand.nextDouble() + min;
		}
	}

}